import javax.xml.parsers.*; 
import org.w3c.dom.*; 

public class parser 
{
    static String displayText[] = new String[1000];
    static int numberOfLines = 0;

    public static void parseDocument(String uri) 
    {
        try {

            DocumentBuilderFactory dbf =
                DocumentBuilderFactory.newInstance();

            DocumentBuilder db = null;
            try {
                db = dbf.newDocumentBuilder();
            } 
            catch (ParserConfigurationException pce) {}

            Document document = null;
            document = db.parse(uri);

            walkNodes(document, "");

        } catch (Exception e) {
            e.printStackTrace(System.err);
        }

    } 

    public static void walkNodes(Node node, String indent) 
    {
        if (node == null) {
            return;
        }

        int type = node.getNodeType();

        switch (type) {
            case Node.DOCUMENT_NODE: {
                displayText[numberOfLines] = indent;
                displayText[numberOfLines] += 
                  "<?xml version=\"1.0\" encoding=\""+
                  "UTF-8" + "\"?>";
                numberOfLines++;
                walkNodes(((Document)node).getDocumentElement(), "");
                break;
             }

             case Node.ELEMENT_NODE: {
                 displayText[numberOfLines] = indent;
                 displayText[numberOfLines] += "<";
                 displayText[numberOfLines] += 
                   node.getNodeName();

                 int length = (node.getAttributes() != null) ? 
                   node.getAttributes().getLength() : 0;
                 Attr attributes[] = new Attr[length];
                 for (int loopIndex = 0; loopIndex < length; 
                   loopIndex++) {
                     attributes[loopIndex] = 
                      (Attr)node.getAttributes().item(loopIndex);
                 }

                 for (int loopIndex = 0; loopIndex < 
                   attributes.length; loopIndex++) {
                     Attr attribute = attributes[loopIndex];
                     displayText[numberOfLines] += " ";
                     displayText[numberOfLines] += 
                       attribute.getNodeName();
                     displayText[numberOfLines] += "=\"";
                     displayText[numberOfLines] += 
                       attribute.getNodeValue();
                     displayText[numberOfLines] += "\"";
                 }
                 displayText[numberOfLines] += ">";

                 numberOfLines++;

                 NodeList childNodes = node.getChildNodes();
                 if (childNodes != null) {
                     length = childNodes.getLength();
                     indent += "    ";
                     for (int loopIndex = 0; loopIndex < length; 
                       loopIndex++ ) {
                        walkNodes(childNodes.item(loopIndex), indent);
                     }
                 }
                 break;
             }

             case Node.CDATA_SECTION_NODE: {
                 displayText[numberOfLines] = indent;
                 displayText[numberOfLines] += "<![CDATA[";
                 displayText[numberOfLines] += 
                   node.getNodeValue();
                 displayText[numberOfLines] += "]]>";
                 numberOfLines++;
                 break;
             }

             case Node.TEXT_NODE: {
                 displayText[numberOfLines] = indent;
                 String newText = node.getNodeValue().trim();
                 if(newText.indexOf("\n") < 0 && newText.length() > 0) 
                 {
                     displayText[numberOfLines] += newText;
                     numberOfLines++;
                 }
                 break;
             }

             case Node.PROCESSING_INSTRUCTION_NODE: {
                 displayText[numberOfLines] = indent;
                 displayText[numberOfLines] += "<?";
                 displayText[numberOfLines] += 
                   node.getNodeName();
                 String text = node.getNodeValue();
                 if (text != null && text.length() > 0) {
                     displayText[numberOfLines] += text;
                 }
                 displayText[numberOfLines] += "?>";
                 numberOfLines++;
                 break;
            }    
        }

        if (type == Node.ELEMENT_NODE) {
            displayText[numberOfLines] = indent.substring(0, 
             indent.length() - 4);
            displayText[numberOfLines] += "</";
            displayText[numberOfLines] += node.getNodeName();
            displayText[numberOfLines] += ">";
            numberOfLines++;
            indent += "    ";
        }
    } 

    public static void main(String args[]) 
    {
        parseDocument(args[0]);

        for(int loopIndex = 0; loopIndex < numberOfLines; 
          loopIndex++){
            System.out.println(displayText[loopIndex]);
        }
    } 
}